var version=1.2;
var request;
var mouse_is_down = false;
var timer;
var no_update_available = true;
//var mouse_out_timer;
var second_count=0;
var xy;

document.captureEvents(Event.MOUSEMOVE);
document.onmousemove = updateTracking;
document.onmouseup = mouseUpEvent;
// check to see if we are in a widget

if (window.widget)
{
   widget.onshow = onshow;
   widget.onhide = onhide;
}

function onshow()
{
    if(no_update_available)
    {
        timer = setInterval(fetchActivityList,600000);
        fetchActivityList();
    }
        
    
}
function onhide()
{
    
        clearInterval(timer);
        timer=null;
    
}

function setup()
{
    //reset the time
    widget.setPreferenceForKey(0,"unixTime");
    checkVersion();
}
function checkVersion()
{
    //alert("checking version...");
    pageURL ="http://www.intellitools.com/icsaex/data/xml.php?action=fetchVersion&appName=dash";
    request = new XMLHttpRequest();
    request.open("GET", pageURL, false);
    request.send();
    appInfo= request.responseXML.documentElement;
    currentVersion = appInfo.getElementsByTagName("version")[0].firstChild.data;
    //alert("current version ="+parseFloat(currentVersion));
    //alert("installed version ="+version);
    if(parseFloat(currentVersion)>version)
    {
        updateURL=appInfo.getElementsByTagName("url")[0].firstChild.data;
        HTML="<a href='#' onclick='goTo(\""+updateURL+"\");'>Version "+currentVersion+" is now available</a>";
        //alert(HTML);
        document.getElementById("fetchedHTML").innerHTML=HTML;
        no_update_available=false;
    }
}

function fetchTime()
{
    pageURL ="http://www.intellitools.com/icsaex/data/xml.php?action=fetchTime";
    request = new XMLHttpRequest();
    request.open("GET", pageURL, false);
    request.send();
    unixTime= request.responseXML.documentElement;
    time = unixTime.getElementsByTagName("time")[0].firstChild.data;
    //alert(time);
    widget.setPreferenceForKey(time,"unixTime");
}
function fetchActivityList()
{ 
    //widget.system("/usr/bin/say 'fetching the activity list'",null);
    unixTime = parseInt(widget.preferenceForKey("unixTime") );
    //if the preferences did not exists we will set them here
    //if(unixTime == "undefined")
    //{
        //unixTime = 0; 
    //}
    pageURL ="http://www.intellitools.com/icsaex/data/xml.php?action=fetchActivityList&unixTime="+unixTime;
    
    request = new XMLHttpRequest();
    request.open("GET", pageURL, false);
    request.send();
    if(request.responseText!="")
    {
        recent_activities = request.responseXML.documentElement;
        activities = recent_activities.getElementsByTagName("activity");
        myCount = activities.length;
        var formattedString="";
        for (i=0 ; i< myCount ; i++ )
        {
            act_key = recent_activities.getElementsByTagName("act_key")[i].firstChild.data
            act_name =recent_activities.getElementsByTagName("act_name")[i].firstChild.data
            act_description =recent_activities.getElementsByTagName("act_description")[i].firstChild.data
            formattedString +="<a href='#' onclick='getInfo(\""+act_key+"\");'>"+act_name+"</a><br>"+act_description+"<hr>";   
        }
        widget.setPreferenceForKey(formattedString,"formattedString");
        fetchTime();
    }
    document.getElementById("fetchedHTML").innerHTML=widget.preferenceForKey("formattedString");
    measureAssets();
    
}
function mouseOutEvent()
{
    if(mouse_out_timer==null && mouse_is_down)
    {
        //set a timer for the mouseout of 1 second
       var mouse_out_timer = setInterval("mouseUpEvent();", 1000);
    }else{
        mouse_out_timer=null;
    }
    
}

function mouseEnterEvent()
{
    if(mouse_out_timer!=null && mouse_is_down)
    {
        clearInterval(mouse_out_timer);
        mouse_out_timer=null;
     }
}
function mouseDownEvent()
{
    mouse_is_down=true;
    //startMouseTracking()
    updateTracking();
}
function mouseUpEvent()
{
    
    mouse_is_down=false;

}

var currentContent;
var currentContentStyle;
var currentContentTop;
var currentContentHeigh;
var viewHeight;
var textScrollSpan;

function measureAssets()
{
    currentContent = document.getElementById("fetchedHTML");
    currentContent.style.display = 'block';
    currentContentStyle = document.defaultView.getComputedStyle(currentContent,'');
    currentContentTop = parseInt(currentContentStyle.getPropertyValue('top'));
    currentContentHeight = parseInt(currentContentStyle.getPropertyValue('height'));
    
    viewHeight = parseFloat (document.defaultView.getComputedStyle(currentContent.parentNode, '').getPropertyValue('height'));
    
    textScrollSpan = currentContentHeight-viewHeight;


}
function updateTracking()
{
    scrollMin = 58;
    scrollMax = 168;
    scrollSpan = scrollMax-scrollMin;
    if( mouse_is_down)
    {
        tempY = event.clientY + document.body.scrollTop;  
        if (tempY < 0){tempY = 0;}
        newY = tempY;
        if(newY<scrollMin)
        {
            newY=scrollMin;
        } 
        if(newY>scrollMax)
        {
            newY=scrollMax;
        }
        scrollLoc = newY-scrollMin;
        scrollPercent = scrollLoc/scrollSpan;
        
        
        
        newTextTop = textScrollSpan*scrollPercent;
        //alert(newTextTop);
        //document.getElementById("fetchedHTML").style.top=-(textUnit*scrollPercent);
        if(newY >= scrollMin && newY <= scrollMax)
        {
            document.getElementById("scrollWidget").style.top = newY-15;
            document.getElementById("fetchedHTML").style.top = 0-newTextTop;
        }

    }
    
}

function goTo(url)
{
    widget.openURL(url);
}
function getInfo(act_key)
{
    gotoURL = "http://www.intellitools.com/icsaex/searchdetails.php?act_key="+act_key+"&dash";
    widget.openURL(gotoURL);
}
// this whole bunch is just because of the fading info stuff
// taken from: file:///Developer/ADC\ Reference Library/documentation/AppleApplications/Conceptual/Dashboard_Tutorial/index.html#//apple_ref/doc/uid/TP40001340
var flipShown = false;
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};
function mousemove (event)
{
    if (!flipShown)
    {
        if (animation.timer != null)
        {
            clearInterval (animation.timer);
            animation.timer  = null;
        }
                
        var starttime = (new Date).getTime() - 13;
                
        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById ('flip');
        animation.timer = setInterval ("animate();", 13);
        animation.from = animation.now;
        animation.to = 1.0;
        animate();
        flipShown = true;
    }
}
function animate()
{
    var T;
    var ease;
    var time = (new Date).getTime();
                
        
    T = limit_3(time-animation.starttime, 0, animation.duration);
        
    if (T >= animation.duration)
    {
        clearInterval (animation.timer);
        animation.timer = null;
        animation.now = animation.to;
    }
    else
    {
        ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
        animation.now = computeNextFloat (animation.from, animation.to, ease);
    }
        
    animation.firstElement.style.opacity = animation.now;
}
function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}
function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}
// done with the animation stuff


// this shows the preferences (again taken from the ADC documentation)
function showPrefs()
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");
        
    if (window.widget)
        widget.prepareForTransition("ToBack");
                
    front.style.display="none";
    back.style.display="block";
        
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);
}
function hidePrefs()
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");
        
    if (window.widget)
        widget.prepareForTransition("ToFront");
                
    front.style.display="block";
    back.style.display="none";
        
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);
}

function enterflip(event)
{
    document.getElementById('fliprollie').style.display = 'block';
}
function exitflip(event)
{
    document.getElementById('fliprollie').style.display = 'none';
}

